searchNodes=[{"doc":"Functions to operate basic commands with tensors.","ref":"Tensorex.html","title":"Tensorex","type":"module"},{"doc":"Checks if the given tensor is diagonal or not.iex&gt; Tensorex.diagonal?(Tensorex.from_list([[2, 0, 0], ...&gt; [0, 3, 0], ...&gt; [0, 0, -9]])) true iex&gt; Tensorex.diagonal?(Tensorex.from_list([[ 2 , 0, 0], ...&gt; [ 0 , 3, 0], ...&gt; [-5.3, 0, -9]])) false","ref":"Tensorex.html#diagonal?/1","title":"Tensorex.diagonal?/1","type":"function"},{"doc":"Returns a tensor or a number stored at the index.The key can be a list of indices or ranges. If integer indices are given, it returns a tensor or a numeric value specified by the index. If ranges are given, it returns a tensor consisting partial elements.Negative indices are counted from the end.iex&gt; Tensorex.from_list([[[ 1 , -3.1, 2 ], ...&gt; [ 4 , 5 , -6.1], ...&gt; [ 0.9 , -91.2, 11 ]], ...&gt; [[10 , -30.1, 20 ], ...&gt; [40 , 50 , -60.1], ...&gt; [ 0.09, -910.2, 110 ]]])[[0, 0, 0]] 1 iex&gt; Tensorex.from_list([[[ 1 , -3.1, 2 ], ...&gt; [ 4 , 5 , -6.1], ...&gt; [ 0.9 , -91.2, 11 ]], ...&gt; [[10 , -30.1, 20 ], ...&gt; [40 , 50 , -60.1], ...&gt; [ 0.09, -910.2, 110 ]]])[[0, 0]] %Tensorex{data: %{[0] =&gt; 1, [1] =&gt; -3.1, [2] =&gt; 2}, shape: [3]} iex&gt; Tensorex.from_list([[[ 1 , -3.1, 2 ], ...&gt; [ 4 , 5 , -6.1], ...&gt; [ 0.9 , -91.2, 11 ]], ...&gt; [[10 , -30.1, 20 ], ...&gt; [40 , 50 , -60.1], ...&gt; [ 0.09, -910.2, 110 ]]])[[0]] %Tensorex{data: %{[0, 0] =&gt; 1 , [0, 1] =&gt; -3.1, [0, 2] =&gt; 2 , [1, 0] =&gt; 4 , [1, 1] =&gt; 5 , [1, 2] =&gt; -6.1, [2, 0] =&gt; 0.9, [2, 1] =&gt; -91.2, [2, 2] =&gt; 11 }, shape: [3, 3]} iex&gt; Tensorex.from_list([[[ 1 , -3.1, 2 ], ...&gt; [ 4 , 5 , -6.1], ...&gt; [ 0.9 , -91.2, 11 ]], ...&gt; [[10 , -30.1, 20 ], ...&gt; [40 , 50 , -60.1], ...&gt; [ 0.09, -910.2, 110 ]]])[[2]] nil iex&gt; Tensorex.from_list([[ 1, 2, 3], ...&gt; [ 4, 5, 6], ...&gt; [ 7, 8, 9], ...&gt; [10, 11, 12]])[[1..2]] %Tensorex{data: %{[0, 0] =&gt; 4, [0, 1] =&gt; 5, [0, 2] =&gt; 6, [1, 0] =&gt; 7, [1, 1] =&gt; 8, [1, 2] =&gt; 9}, shape: [2, 3]} iex&gt; Tensorex.from_list([[ 1, 2, 3], ...&gt; [ 4, 5, 6], ...&gt; [ 7, 8, 9], ...&gt; [10, 11, 12]])[[-2..-1]] %Tensorex{data: %{[0, 0] =&gt; 7, [0, 1] =&gt; 8, [0, 2] =&gt; 9, [1, 0] =&gt; 10, [1, 1] =&gt; 11, [1, 2] =&gt; 12}, shape: [2, 3]} iex&gt; Tensorex.from_list([[ 1, 2, 3], ...&gt; [ 4, 5, 6], ...&gt; [ 7, 8, 9], ...&gt; [10, 11, 12]])[[1..2, 1..-1]] %Tensorex{data: %{[0, 0] =&gt; 5, [0, 1] =&gt; 6, [1, 0] =&gt; 8, [1, 1] =&gt; 9}, shape: [2, 2]} iex&gt; Tensorex.from_list([[ 1, 2, 3], ...&gt; [ 4, 0, 6], ...&gt; [ 7, 8, 9], ...&gt; [10, 11, 12]])[[1, 1]] 0.0","ref":"Tensorex.html#fetch/2","title":"Tensorex.fetch/2","type":"function"},{"doc":"Creates a new tensor from a list (of lists (of lists of ...)).iex&gt; Tensorex.from_list([1.1, 2.1, -5.3, 4]) %Tensorex{data: %{[0] =&gt; 1.1, [1] =&gt; 2.1, [2] =&gt; -5.3, [3] =&gt; 4}, shape: [4]} iex&gt; Tensorex.from_list([[1.1, 2.1, -5.3, 4 ], ...&gt; [0.8, -8, 21.4, 3.3]]) %Tensorex{data: %{[0, 0] =&gt; 1.1, [0, 1] =&gt; 2.1, [0, 2] =&gt; -5.3, [0, 3] =&gt; 4 , [1, 0] =&gt; 0.8, [1, 1] =&gt; -8, [1, 2] =&gt; 21.4, [1, 3] =&gt; 3.3}, shape: [2, 4]} iex&gt; Tensorex.from_list([[[0.0, 0.0, 0.0], ...&gt; [0.0, 0.0, 0.0]], ...&gt; [[0.0, 0.0, 0.0], ...&gt; [0.0, 0.0, 0.0]]]) %Tensorex{data: %{}, shape: [2, 2, 3]}","ref":"Tensorex.html#from_list/1","title":"Tensorex.from_list/1","type":"function"},{"doc":"Returns a tensor or a number stored at the index and update it at the same time.iex&gt; get_and_update_in( ...&gt; Tensorex.from_list([[[ 1 , -3.1, 2 ], ...&gt; [ 4 , 5 , -6.1], ...&gt; [ 0.9 , -91.2, 11 ]], ...&gt; [[10 , -30.1, 20 ], ...&gt; [40 , 50 , -60.1], ...&gt; [ 0.09, -910.2, 110 ]]])[[0, 1, 0]], &amp;{&amp;1, &amp;1 * 3.5}) {4, %Tensorex{data: %{[0, 0, 0] =&gt; 1 , [0, 0, 1] =&gt; -3.1, [0, 0, 2] =&gt; 2 , [0, 1, 0] =&gt; 14.0 , [0, 1, 1] =&gt; 5 , [0, 1, 2] =&gt; -6.1, [0, 2, 0] =&gt; 0.9 , [0, 2, 1] =&gt; -91.2, [0, 2, 2] =&gt; 11 , [1, 0, 0] =&gt; 10 , [1, 0, 1] =&gt; -30.1, [1, 0, 2] =&gt; 20 , [1, 1, 0] =&gt; 40 , [1, 1, 1] =&gt; 50 , [1, 1, 2] =&gt; -60.1, [1, 2, 0] =&gt; 0.09, [1, 2, 1] =&gt; -910.2, [1, 2, 2] =&gt; 110 }, shape: [2, 3, 3]}} iex&gt; get_and_update_in( ...&gt; Tensorex.from_list([[ 1, 2, 3], ...&gt; [ 4, 5, 6], ...&gt; [ 7, 8, 9], ...&gt; [10, 11, 12]])[[1..2, 1..2]], ...&gt; &amp;{&amp;1, Tensorex.from_list([[13, 14], ...&gt; [15, 16]])}) {%Tensorex{data: %{[0, 0] =&gt; 5, [0, 1] =&gt; 6, [1, 0] =&gt; 8, [1, 1] =&gt; 9}, shape: [2, 2]}, %Tensorex{data: %{[0, 0] =&gt; 1, [0, 1] =&gt; 2, [0, 2] =&gt; 3, [1, 0] =&gt; 4, [1, 1] =&gt; 13, [1, 2] =&gt; 14, [2, 0] =&gt; 7, [2, 1] =&gt; 15, [2, 2] =&gt; 16, [3, 0] =&gt; 10, [3, 1] =&gt; 11, [3, 2] =&gt; 12}, shape: [4, 3]}} iex&gt; get_and_update_in( ...&gt; Tensorex.from_list([[ 1, 2, 3], ...&gt; [ 4, 5, 6], ...&gt; [ 7, 8, 9], ...&gt; [10, 11, 12]])[[2]], ...&gt; &amp;{&amp;1, Tensorex.from_list([0, 0, 16])}) {%Tensorex{data: %{[0] =&gt; 7, [1] =&gt; 8, [2] =&gt; 9}, shape: [3]}, %Tensorex{data: %{[0, 0] =&gt; 1, [0, 1] =&gt; 2, [0, 2] =&gt; 3, [1, 0] =&gt; 4, [1, 1] =&gt; 5, [1, 2] =&gt; 6, [2, 2] =&gt; 16, [3, 0] =&gt; 10, [3, 1] =&gt; 11, [3, 2] =&gt; 12}, shape: [4, 3]}} iex&gt; get_and_update_in( ...&gt; Tensorex.from_list([[ 1, 2], ...&gt; [ 3, 4]])[[0..-1, 0..-1]], ...&gt; &amp;{&amp;1, Tensorex.from_list([[-2, 0], ...&gt; [ 0, -3]])}) {%Tensorex{data: %{[0, 0] =&gt; 1, [0, 1] =&gt; 2, [1, 0] =&gt; 3, [1, 1] =&gt; 4}, shape: [2, 2]}, %Tensorex{data: %{[0, 0] =&gt; -2, [1, 1] =&gt; -3}, shape: [2, 2]}} iex&gt; get_and_update_in( ...&gt; Tensorex.zero([3, 2])[[1..-1, 1..-1]], ...&gt; &amp;{&amp;1, Tensorex.from_list([[ 1], ...&gt; [-1]])}) {%Tensorex{data: %{}, shape: [2, 1]}, %Tensorex{data: %{[1, 1] =&gt; 1, [2, 1] =&gt; -1}, shape: [3, 2]}}","ref":"Tensorex.html#get_and_update/3","title":"Tensorex.get_and_update/3","type":"function"},{"doc":"Returns a 2-rank tensor with all diagonal elements of 1.iex&gt; Tensorex.kronecker_delta(3) %Tensorex{data: %{[0, 0] =&gt; 1, [1, 1] =&gt; 1, [2, 2] =&gt; 1}, shape: [3, 3]}","ref":"Tensorex.html#kronecker_delta/1","title":"Tensorex.kronecker_delta/1","type":"function"},{"doc":"Pops the tensor or the number stored at the index out of the tensor.iex&gt; pop_in( ...&gt; Tensorex.from_list([[[ 1 , -3.1, 2 ], ...&gt; [ 4 , 5 , -6.1], ...&gt; [ 0.9 , -91.2, 11 ]], ...&gt; [[10 , -30.1, 20 ], ...&gt; [40 , 50 , -60.1], ...&gt; [ 0.09, -910.2, 110 ]]])[[0]]) {%Tensorex{data: %{[0, 0] =&gt; 1, [0, 1] =&gt; -3.1 , [0, 2] =&gt; 2 , [1, 0] =&gt; 4, [1, 1] =&gt; 5 , [1, 2] =&gt; -6.1, [2, 0] =&gt; 0.9, [2, 1] =&gt; -91.2, [2, 2] =&gt; 11 }, shape: [3, 3]}, %Tensorex{data: %{[1, 0, 0] =&gt; 10 , [1, 0, 1] =&gt; -30.1, [1, 0, 2] =&gt; 20 , [1, 1, 0] =&gt; 40 , [1, 1, 1] =&gt; 50 , [1, 1, 2] =&gt; -60.1, [1, 2, 0] =&gt; 0.09, [1, 2, 1] =&gt; -910.2, [1, 2, 2] =&gt; 110 }, shape: [2, 3, 3]}} iex&gt; pop_in( ...&gt; Tensorex.from_list([[[ 1 , -3.1, 2 ], ...&gt; [ 4 , 5 , -6.1], ...&gt; [ 0.9 , -91.2, 11 ]], ...&gt; [[10 , -30.1, 20 ], ...&gt; [40 , 50 , -60.1], ...&gt; [ 0.09, -910.2, 110 ]]])[[0, 1, 2]]) {-6.1, %Tensorex{data: %{[0, 0, 0] =&gt; 1 , [0, 0, 1] =&gt; -3.1, [0, 0, 2] =&gt; 2 , [0, 1, 0] =&gt; 4 , [0, 1, 1] =&gt; 5 , [0, 2, 0] =&gt; 0.9 , [0, 2, 1] =&gt; -91.2, [0, 2, 2] =&gt; 11 , [1, 0, 0] =&gt; 10 , [1, 0, 1] =&gt; -30.1, [1, 0, 2] =&gt; 20 , [1, 1, 0] =&gt; 40 , [1, 1, 1] =&gt; 50 , [1, 1, 2] =&gt; -60.1, [1, 2, 0] =&gt; 0.09, [1, 2, 1] =&gt; -910.2, [1, 2, 2] =&gt; 110 }, shape: [2, 3, 3]}}","ref":"Tensorex.html#pop/2","title":"Tensorex.pop/2","type":"function"},{"doc":"Checks if the given tensor is upper triangular or not.iex&gt; Tensorex.triangular?(Tensorex.from_list([[2, 1, 3], ...&gt; [0, 3, 6], ...&gt; [0, 0, -9]])) true iex&gt; Tensorex.triangular?(Tensorex.from_list([[2, 0, 0], ...&gt; [0, 3, 0], ...&gt; [3, 0, -9]])) false iex&gt; Tensorex.triangular?(Tensorex.from_list([[[2, 5], [0, 1]], ...&gt; [[0, 0], [0, -2]], ...&gt; [[0, 0], [0, 0]]])) true iex&gt; Tensorex.triangular?(Tensorex.from_list([[[2, 5], [0, 1]], ...&gt; [[6, 0], [0, -2]], ...&gt; [[0, 0], [0, 0]]])) false","ref":"Tensorex.html#triangular?/1","title":"Tensorex.triangular?/1","type":"function"},{"doc":"Returns a tensor with all of zero elements.iex&gt; Tensorex.zero([4, 4, 2]) %Tensorex{data: %{}, shape: [4, 4, 2]}","ref":"Tensorex.html#zero/1","title":"Tensorex.zero/1","type":"function"},{"doc":"Represents a tensor.The data structure is a map with list of indices keys and numeric values. Zero values are omitted. The shape is a list of each dimension at the order.This module implements the Access behaviour. So that you can access elements of the tensor via tensor[indices] syntax, where indices must be a list of integer/0s or Range.t/0s. See fetch/2 for concrete examples.","ref":"Tensorex.html#t:t/0","title":"Tensorex.t/0","type":"type"},{"doc":"Functions for tensor (or matrix) analysis.Matrices are represented as 2-rank tensors.","ref":"Tensorex.Analyzer.html","title":"Tensorex.Analyzer","type":"module"},{"doc":"Bidiagonalizes a matrix.Returns a 3-element tuple containing the left-side orthogonal matrix (U), the bidiagonalized matrix (A) and the right-side orthogonal matrix (V). The dot product of them (U·A·V) results to the given matrix.iex&gt; Tensorex.Analyzer.bidiagonalize(Tensorex.from_list([[1, 3], ...&gt; [2, 4]])) { %Tensorex{data: %{[0, 0] =&gt; -0.4472135954999581, [0, 1] =&gt; -0.8944271909999159, [1, 0] =&gt; -0.8944271909999159, [1, 1] =&gt; 0.447213595499958 }, shape: [2, 2]}, %Tensorex{data: %{[0, 0] =&gt; -2.23606797749979 , [0, 1] =&gt; -4.919349550499538 , [1, 1] =&gt; -0.8944271909999157}, shape: [2, 2]}, %Tensorex{data: %{[0, 0] =&gt; 1, [1, 1] =&gt; 1 }, shape: [2, 2]} } iex&gt; Tensorex.Analyzer.bidiagonalize(Tensorex.from_list([[1, 3], ...&gt; [2, 4], ...&gt; [8, 7]])) { %Tensorex{data: %{[0, 0] =&gt; -0.12038585308576932, [0, 1] =&gt; -0.6785172735171086, [0, 2] =&gt; -0.7246527140056269 , [1, 0] =&gt; -0.24077170617153842, [1, 1] =&gt; -0.6882103774244954, [1, 2] =&gt; 0.6843942298942036 , [2, 0] =&gt; -0.9630868246861537 , [2, 1] =&gt; 0.2568672535457624, [2, 2] =&gt; -0.08051696822284758}, shape: [3, 3]}, %Tensorex{data: %{[0, 0] =&gt; -8.306623862918075 , [0, 1] =&gt; -8.065852156746537 , [1, 1] =&gt; -2.9903225554289703}, shape: [3, 2]}, %Tensorex{data: %{[0, 0] =&gt; 1 , [1, 1] =&gt; 1 }, shape: [2, 2]} } iex&gt; Tensorex.Analyzer.bidiagonalize(Tensorex.from_list([[1, 3, 4], ...&gt; [2, 4, 7], ...&gt; [6, 8, 9]])) { %Tensorex{data: %{[0, 0] =&gt; -0.1561737618886061 , [0, 1] =&gt; -0.5866584511916395, [0, 2] =&gt; -0.7946330082138469 , [1, 0] =&gt; -0.31234752377721214, [1, 1] =&gt; -0.7338871586541569, [1, 2] =&gt; 0.6031986925986929 , [2, 0] =&gt; -0.9370425713316364 , [2, 1] =&gt; 0.3424054614166589, [2, 2] =&gt; -0.06862739616392308}, shape: [3, 3]}, %Tensorex{data: %{[0, 0] =&gt; -6.4031242374328485 , [0, 1] =&gt; 14.537587950366257 , [1, 1] =&gt; 4.644937425077393 , [1, 2] =&gt; -1.277069945154351 , [2, 2] =&gt; 0.6724472155230544 }, shape: [3, 3]}, %Tensorex{data: %{[0, 0] =&gt; 1 , [1, 1] =&gt; -0.6338226109370237, [1, 2] =&gt; -0.7734784404655207 , [2, 1] =&gt; -0.7734784404655207, [2, 2] =&gt; 0.633822610937024 }, shape: [3, 3]} } iex&gt; Tensorex.Analyzer.bidiagonalize(Tensorex.from_list([[2, -4, 8], ...&gt; [3, 5, 6], ...&gt; [1, 9, 11], ...&gt; [7, 12, 13]])) { %Tensorex{data: %{[0, 0] =&gt; -0.25197631533948517, [0, 1] =&gt; 0.11018150006547239 , [0, 2] =&gt; -0.9605551708365737 , [0, 3] =&gt; 0.041252119101685414, [1, 0] =&gt; -0.37796447300922725, [1, 1] =&gt; 0.020828566102646506, [1, 2] =&gt; 0.06187677855532897, [1, 3] =&gt; -0.9235151824699903 , [2, 0] =&gt; -0.12598815766974245, [2, 1] =&gt; -0.9885657272873108 , [2, 2] =&gt; -0.0793161285954799 , [2, 3] =&gt; 0.0239528433493658 , [3, 0] =&gt; -0.881917103688197 , [3, 1] =&gt; 0.1008167184069181 , [3, 2] =&gt; 0.2592565906575201 , [3, 3] =&gt; 0.3805840665510335 }, shape: [4, 4]}, %Tensorex{data: %{[0, 0] =&gt; -7.937253933193772 , [0, 1] =&gt; 21.267756353632144 , [1, 1] =&gt; 11.647368945587411 , [1, 2] =&gt; 1.3952492335365543 , [2, 2] =&gt; -8.128629398872933 }, shape: [4, 3]}, %Tensorex{data: %{[0, 0] =&gt; 1 , [1, 1] =&gt; -0.5923904504775179 , [1, 2] =&gt; -0.8056510126494246 , [2, 1] =&gt; -0.8056510126494246 , [2, 2] =&gt; 0.592390450477518 }, shape: [3, 3]} } iex&gt; Tensorex.Analyzer.bidiagonalize(Tensorex.from_list([[1, 3, 5], ...&gt; [2, 4, 6]])) { %Tensorex{data: %{[0, 0] =&gt; -0.4472135954999581, [0, 1] =&gt; -0.8944271909999159, [1, 0] =&gt; -0.8944271909999159, [1, 1] =&gt; 0.447213595499958 }, shape: [2, 2]}, %Tensorex{data: %{[0, 0] =&gt; -2.23606797749979 , [0, 1] =&gt; 9.055385138137419 , [1, 1] =&gt; 1.9877674693472376, [1, 2] =&gt; -0.22086305214969304}, shape: [2, 3]}, %Tensorex{data: %{[0, 0] =&gt; 1 , [1, 1] =&gt; -0.5432512781572743, [1, 2] =&gt; -0.8395701571521512 , [2, 1] =&gt; -0.8395701571521512, [2, 2] =&gt; 0.5432512781572743 }, shape: [3, 3]} }","ref":"Tensorex.Analyzer.html#bidiagonalize/1","title":"Tensorex.Analyzer.bidiagonalize/1","type":"function"},{"doc":"Diagonalizes a square matrix.Returns a 2-element tuple containing the diagonalized matrix (D) and the square matrix (P) composed of eigen vectors of the given matrix. The dot product of (P·D·P^-1) results to the given matrix.iex&gt; Tensorex.Analyzer.eigen_decomposition(Tensorex.from_list([[8, 1], ...&gt; [4, 5]])) { %Tensorex{data: %{[0, 0] =&gt; 9.0 , [1, 1] =&gt; 4.0 }, shape: [2, 2]}, %Tensorex{data: %{[0, 0] =&gt; 0.7071067811865475, [0, 1] =&gt; 0.24253562503633297, [1, 0] =&gt; 0.7071067811865475, [1, 1] =&gt; -0.9701425001453319 }, shape: [2, 2]} } iex&gt; Tensorex.Analyzer.eigen_decomposition(Tensorex.from_list([[2, 0], ...&gt; [0, 3]])) { %Tensorex{data: %{[0, 0] =&gt; 2, [1, 1] =&gt; 3}, shape: [2, 2]}, %Tensorex{data: %{[0, 0] =&gt; 1, [1, 1] =&gt; 1}, shape: [2, 2]} } iex&gt; Tensorex.Analyzer.eigen_decomposition(Tensorex.from_list([[2, 0], ...&gt; [4, 3]])) { %Tensorex{data: %{[0, 0] =&gt; 3.0, [1, 1] =&gt; 2.0 }, shape: [2, 2]}, %Tensorex{data: %{ [0, 1] =&gt; -0.24253562503633297, [1, 0] =&gt; 1 , [1, 1] =&gt; 0.9701425001453319 }, shape: [2, 2]} } iex&gt; Tensorex.Analyzer.eigen_decomposition(Tensorex.from_list([[ 1, 8, 4], ...&gt; [-3, 2, -6], ...&gt; [ 8, -9, 11]])) { %Tensorex{data: %{[0, 0] =&gt; 15.303170410844274 , [1, 1] =&gt; -3.3868958657320674, [2, 2] =&gt; 2.0837254548877966 }, shape: [3, 3]}, %Tensorex{data: %{[0, 0] =&gt; 0.022124491408649645, [0, 1] =&gt; 0.8133941080334768, [0, 2] =&gt; 0.8433114989223975 , [1, 0] =&gt; -0.4151790326348706 , [1, 1] =&gt; -0.1674957147614615, [1, 2] =&gt; 0.32735161385148664, [2, 0] =&gt; 0.909470657987536 , [2, 1] =&gt; -0.5570773829127975, [2, 2] =&gt; -0.4262236932575271 }, shape: [3, 3]} } iex&gt; Tensorex.Analyzer.eigen_decomposition(Tensorex.from_list([[ 1, 8, 4, -8, 6], ...&gt; [ 8, 2, -6, 15, 4], ...&gt; [ 4, -6, 11, 7, 9], ...&gt; [-8, 15, 7, 3, 2], ...&gt; [ 6, 4, 9, 2, 6]])) { %Tensorex{data: %{[0, 0] =&gt; 22.48141136723747 , [1, 1] =&gt; -21.990125946333524 , [2, 2] =&gt; 15.981743258501801 , [3, 3] =&gt; 9.870440666608177 , [4, 4] =&gt; -3.3434693460139164 }, shape: [5, 5]}, %Tensorex{data: %{[0, 0] =&gt; 0.22485471488273154, [0, 1] =&gt; 0.4533959138705312 , [0, 2] =&gt; 0.15613132580124428, [0, 3] =&gt; 0.6959350745397415 , [0, 4] =&gt; 0.48494317564991224 , [1, 0] =&gt; 0.3411622703810978 , [1, 1] =&gt; -0.5996180449764692 , [1, 2] =&gt; -0.6337681498982659 , [1, 3] =&gt; 0.31120102182464826, [1, 4] =&gt; 0.15986982703698566 , [2, 0] =&gt; 0.5907934013280463 , [2, 1] =&gt; -0.3000622953270929 , [2, 2] =&gt; 0.5126463927515507 , [2, 3] =&gt; -0.38215013214304583, [2, 4] =&gt; 0.38997529200213504 , [3, 0] =&gt; 0.4381110287686999 , [3, 1] =&gt; 0.5856554959326528 , [3, 2] =&gt; -0.5216463205486719 , [3, 3] =&gt; -0.4370125068120504 , [3, 4] =&gt; 0.044402158764973956, [4, 0] =&gt; 0.5404355150079331 , [4, 1] =&gt; 0.043134724190818236, [4, 2] =&gt; 0.19758475025904781, [4, 3] =&gt; 0.2860238476658191 , [4, 4] =&gt; -0.7649963886964449 }, shape: [5, 5]} }","ref":"Tensorex.Analyzer.html#eigen_decomposition/1","title":"Tensorex.Analyzer.eigen_decomposition/1","type":"function"},{"doc":"Performs the householder conversion.Returns a tuple of the converted vecter and the reflection matrix (P). The dot product of the reflection matrix and the given vector (V) (P·V) results to the converted vector.iex&gt; Tensorex.Analyzer.householder(Tensorex.from_list([2, 3.5, -1.6, 8.2])) { %Tensorex{data: %{[0] =&gt; -9.276313923105448}, shape: [4]}, %Tensorex{data: %{[0, 0] =&gt; -0.21560288025811625, [0, 1] =&gt; -0.3773050404517033 , [0, 2] =&gt; 0.172482304206493 , [0, 3] =&gt; -0.8839718090582762 , [1, 0] =&gt; -0.3773050404517033 , [1, 1] =&gt; 0.8828901314218394 , [1, 2] =&gt; 0.05353593992144486, [1, 3] =&gt; -0.27437169209740486, [2, 0] =&gt; 0.172482304206493 , [2, 1] =&gt; 0.05353593992144486, [2, 2] =&gt; 0.9755264274644824 , [2, 3] =&gt; 0.12542705924452796, [3, 0] =&gt; -0.8839718090582762 , [3, 1] =&gt; -0.27437169209740486, [3, 2] =&gt; 0.12542705924452796, [3, 3] =&gt; 0.3571863213717944 }, shape: [4, 4]} } iex&gt; Tensorex.Analyzer.householder(Tensorex.from_list([3.8, 0.0, 0.0, 0.0, 0.0])) { %Tensorex{data: %{[0] =&gt; 3.8}, shape: [5]}, %Tensorex{data: %{[0, 0] =&gt; 1, [1, 1] =&gt; 1, [2, 2] =&gt; 1, [3, 3] =&gt; 1, [4, 4] =&gt; 1}, shape: [5, 5]} }","ref":"Tensorex.Analyzer.html#householder/1","title":"Tensorex.Analyzer.householder/1","type":"function"},{"doc":"Decomposites a square matrix into a pair of triangular matrices.Returns a 3-element tuple containing a row pivot matrix (P), a lower triangular matrix (L) and an upper triangular matrix (U). The dot product of them (P·L·U) results to the given matrix.iex&gt; Tensorex.Analyzer.lu_decomposition(Tensorex.from_list([[10, 13, 15], ...&gt; [ 5, 7, 9], ...&gt; [ 9, 11, 13]])) { %Tensorex{data: %{[0, 0] =&gt; 1 , [1, 2] =&gt; 1 , [2, 1] =&gt; 1 }, shape: [3, 3]}, %Tensorex{data: %{[0, 0] =&gt; 1 , [1, 0] =&gt; 0.9, [1, 1] =&gt; 1 , [2, 0] =&gt; 0.5, [2, 1] =&gt; -0.7142857142857132, [2, 2] =&gt; 1 }, shape: [3, 3]}, %Tensorex{data: %{[0, 0] =&gt; 10 , [0, 1] =&gt; 13 , [0, 2] =&gt; 15 , [1, 1] =&gt; -0.7000000000000011, [1, 2] =&gt; -0.5 , [2, 2] =&gt; 1.1428571428571435}, shape: [3, 3]} } iex&gt; Tensorex.Analyzer.lu_decomposition(Tensorex.from_list([[ 0, 13, 15], ...&gt; [ 5, 7, 9], ...&gt; [ 9, 11, 13]])) { %Tensorex{data: %{ [0, 1] =&gt; 1 , [1, 2] =&gt; 1 , [2, 0] =&gt; 1 }, shape: [3, 3]}, %Tensorex{data: %{[0, 0] =&gt; 1 , [1, 1] =&gt; 1 , [2, 0] =&gt; 0.5555555555555556, [2, 1] =&gt; 0.06837606837606834, [2, 2] =&gt; 1 }, shape: [3, 3]}, %Tensorex{data: %{[0, 0] =&gt; 9 , [0, 1] =&gt; 11 , [0, 2] =&gt; 13 , [1, 1] =&gt; 13 , [1, 2] =&gt; 15 , [2, 2] =&gt; 0.7521367521367526}, shape: [3, 3]} }","ref":"Tensorex.Analyzer.html#lu_decomposition/1","title":"Tensorex.Analyzer.lu_decomposition/1","type":"function"},{"doc":"Decomposites a matrix into a pair of an orthogonal matrix and an upper triangular matrix.Returns a 2-element tuple containing an orthogonal matrix (Q) and an upper triangular matrix (R). The dot product of them (Q·R) results to the given matrix.iex&gt; Tensorex.Analyzer.qr_decomposition(Tensorex.from_list([[1, 2], ...&gt; [3, 4], ...&gt; [5, 6]])) {%Tensorex{data: %{[0, 0] =&gt; -0.16903085094570347, [0, 1] =&gt; 0.89708522714506 , [1, 0] =&gt; -0.50709255283711 , [1, 1] =&gt; 0.27602622373694213, [2, 0] =&gt; -0.8451542547285165 , [2, 1] =&gt; -0.34503277967117735}, shape: [3, 2]}, %Tensorex{data: %{[0, 0] =&gt; -5.916079783099616 , [0, 1] =&gt; -7.437357441610946 , [1, 1] =&gt; 0.8280786712108249 }, shape: [2, 2]}} iex&gt; Tensorex.Analyzer.qr_decomposition(Tensorex.from_list([[1, 2, 3], ...&gt; [3, 4, 5]])) {%Tensorex{data: %{[0, 0] =&gt; -0.316227766016838 , [0, 1] =&gt; -0.9486832980505137, [1, 0] =&gt; -0.9486832980505137, [1, 1] =&gt; 0.3162277660168382}, shape: [2, 2]}, %Tensorex{data: %{[0, 0] =&gt; -3.1622776601683795, [0, 1] =&gt; -4.42718872423573 , [0, 2] =&gt; -5.692099788303082, [1, 1] =&gt; -0.6324555320336744, [1, 2] =&gt; -1.26491106406735}, shape: [2, 3]}}","ref":"Tensorex.Analyzer.html#qr_decomposition/1","title":"Tensorex.Analyzer.qr_decomposition/1","type":"function"},{"doc":"Finds the singular values and the singular vectors of the given matrix.Returns a 3-element tuple that contains the left singular vectors (U), the diagonal containing singular values (S) and the right singular vectors (V). The dot product of them (U·S·V^T) results to the given matrix.iex&gt; Tensorex.Analyzer.singular_value_decomposition(Tensorex.from_list([[1, 2, 3], ...&gt; [2, 3, 5], ...&gt; [3, 8, 9], ...&gt; [4, 5, 6]])) {%Tensorex{data: %{[0, 0] =&gt; 0.2226615344045355 , [0, 1] =&gt; -0.05855885924201132, [0, 2] =&gt; -0.3843955833877411 , [1, 0] =&gt; 0.36536351530221217, [1, 1] =&gt; 0.15902949910885741, [1, 2] =&gt; -0.8106021820799661 , [2, 0] =&gt; 0.7400203406817314 , [2, 1] =&gt; -0.6059441250735513 , [2, 2] =&gt; 0.2714639225744238 , [3, 0] =&gt; 0.518942422779177 , [3, 1] =&gt; 0.7772465475679571 , [3, 2] =&gt; 0.3485275837286095 }, shape: [4, 3]}, %Tensorex{data: %{[0, 0] =&gt; 16.709361526261223 , [1, 1] =&gt; 1.6718956724884724 , [2, 2] =&gt; 1.0010006218857228 }, shape: [3, 3]}, %Tensorex{data: %{[0, 0] =&gt; 0.3141484053667126 , [0, 1] =&gt; 0.9274824856259514 , [0, 2] =&gt; 0.20269932970451207, [1, 0] =&gt; 0.6018355900828712 , [1, 1] =&gt; -0.3596812252112713 , [1, 2] =&gt; 0.7130381046901498 , [2, 0] =&gt; 0.73423749694166 , [2, 1] =&gt; -0.10200811285199618, [2, 2] =&gt; -0.6711852523686888 }, shape: [3, 3]}}","ref":"Tensorex.Analyzer.html#singular_value_decomposition/1","title":"Tensorex.Analyzer.singular_value_decomposition/1","type":"function"},{"doc":"Solves a system of linear equations.Computes the solution vector (X) of the equation (A·X = B) where A is a matrix and B is a matrix or a vector.iex&gt; Tensorex.Analyzer.solve( ...&gt; Tensorex.from_list([[ 3, 2, 1], ...&gt; [ 4, 7, 6], ...&gt; [11, 8, 9]]), ...&gt; Tensorex.from_list([6, 12, 18]) ...&gt; ) %Tensorex{data: %{[0] =&gt; 1.0000000000000002 , [1] =&gt; 2.0000000000000004 , [2] =&gt; -1.0000000000000007}, shape: [3]}","ref":"Tensorex.Analyzer.html#solve/2","title":"Tensorex.Analyzer.solve/2","type":"function"},{"doc":"Functions for basic arithmetic operations with tensors.","ref":"Tensorex.Operator.html","title":"Tensorex.Operator","type":"module"},{"doc":"Adds two tensors.iex&gt; Tensorex.Operator.add( ...&gt; Tensorex.from_list([[0, 1 , 2 ], ...&gt; [3, -4 , -5.5]]), ...&gt; Tensorex.from_list([[3, -2 , -2 ], ...&gt; [6, -8.1, 12 ]])) %Tensorex{data: %{[0, 0] =&gt; 3, [0, 1] =&gt; -1, [1, 0] =&gt; 9, [1, 1] =&gt; -12.1, [1, 2] =&gt; 6.5}, shape: [2, 3]} iex&gt; Tensorex.Operator.add( ...&gt; Tensorex.from_list([[0 , 1 , 2 ], ...&gt; [3 , -4 , -5.5]]), ...&gt; Tensorex.from_list([[0.0, -1 , -2 ], ...&gt; [6 , -8.1, 12 ]])) %Tensorex{data: %{[1, 0] =&gt; 9, [1, 1] =&gt; -12.1, [1, 2] =&gt; 6.5}, shape: [2, 3]}","ref":"Tensorex.Operator.html#add/2","title":"Tensorex.Operator.add/2","type":"function"},{"doc":"Divides all elements of the tensor by the scalar.iex&gt; Tensorex.Operator.divide( ...&gt; Tensorex.from_list([[2 , 3.5, -1.6, 8.2], ...&gt; [1.1, 3.0, 0 , -12.1]]), 4) %Tensorex{data: %{[0, 0] =&gt; 0.5 , [0, 1] =&gt; 0.875, [0, 2] =&gt; -0.4, [0, 3] =&gt; 2.05 , [1, 0] =&gt; 0.275, [1, 1] =&gt; 0.75 , [1, 3] =&gt; -3.025}, shape: [2, 4]}","ref":"Tensorex.Operator.html#divide/2","title":"Tensorex.Operator.divide/2","type":"function"},{"doc":"Makes a product of tensors.If both arguments are tensors, it returns a tensor product of them. When one of arguments is a number/0, then all elements of the tensor will be amplified by the scalar.iex&gt; Tensorex.Operator.multiply( ...&gt; Tensorex.from_list([2, 5.2, -4 , 0 ]), ...&gt; Tensorex.from_list([2, 3.5, -1.6, 8.2])) %Tensorex{data: %{[0, 0] =&gt; 4 , [0, 1] =&gt; 7.0, [0, 2] =&gt; -3.2 , [0, 3] =&gt; 16.4 , [1, 0] =&gt; 10.4, [1, 1] =&gt; 18.2, [1, 2] =&gt; -8.32, [1, 3] =&gt; 42.64, [2, 0] =&gt; -8 , [2, 1] =&gt; -14.0, [2, 2] =&gt; 6.4 , [2, 3] =&gt; -32.8}, shape: [4, 4]} iex&gt; Tensorex.Operator.multiply(3.5, ...&gt; Tensorex.from_list([[2 , 3.5, -1.5, 8.0], ...&gt; [4.12, -2 , 1 , 0 ]])) %Tensorex{data: %{[0, 0] =&gt; 7.0 , [0, 1] =&gt; 12.25, [0, 2] =&gt; -5.25, [0, 3] =&gt; 28.0, [1, 0] =&gt; 14.42, [1, 1] =&gt; -7.0 , [1, 2] =&gt; 3.5 }, shape: [2, 4]}","ref":"Tensorex.Operator.html#multiply/2","title":"Tensorex.Operator.multiply/2","type":"function"},{"doc":"Makes a dot product of tensors.Components specified by the axes will be sumed up (or contracted).iex&gt; Tensorex.Operator.multiply( ...&gt; Tensorex.from_list([0, 0.0, 0.0, 0 ]), ...&gt; Tensorex.from_list([2, 3.5, -1.6, 8.2]), [{0, 0}]) 0.0 iex&gt; Tensorex.Operator.multiply( ...&gt; Tensorex.from_list([[2 , 3.5, -1.6, 8.2], ...&gt; [1.1, 3.0, 8 , -12.1]]), ...&gt; Tensorex.from_list([[0 , 0.0], ...&gt; [0.0, 0 ], ...&gt; [0.0, 0 ], ...&gt; [0 , 0 ]]), [{0, 1}, {1, 0}]) 0.0 iex&gt; Tensorex.Operator.multiply( ...&gt; Tensorex.from_list([2, 5.2, -4 , 0 ]), ...&gt; Tensorex.from_list([2, 3.5, -1.6, 8.2]), [{0, 0}]) 28.6 iex&gt; Tensorex.Operator.multiply( ...&gt; Tensorex.from_list([[ 2 , 5.5, -4 , 0 ], ...&gt; [ 4.12, -2 , 1 , 0 ]]), ...&gt; Tensorex.from_list([[ 2 , 3.5], ...&gt; [-1.6 , 8.2], ...&gt; [ 2 , -3.5], ...&gt; [-1.5 , 8.0]]), [{0, 1}]) %Tensorex{data: %{[0, 0] =&gt; 18.42, [0, 1] =&gt; 30.584, [0, 2] =&gt; -10.42, [0, 3] =&gt; 29.96, [1, 0] =&gt; 4.0 , [1, 1] =&gt; -25.2 , [1, 2] =&gt; 18.0 , [1, 3] =&gt; -24.25, [2, 0] =&gt; -4.5 , [2, 1] =&gt; 14.6 , [2, 2] =&gt; -11.5 , [2, 3] =&gt; 14.0 }, shape: [4, 4]}","ref":"Tensorex.Operator.html#multiply/3","title":"Tensorex.Operator.multiply/3","type":"function"},{"doc":"Negates a tensor.iex&gt; Tensorex.Operator.negate( ...&gt; Tensorex.from_list([[ 2 , 3.5, -4 , 0 ], ...&gt; [-2.2, 6 , 0.0, 5.5]])) %Tensorex{data: %{[0, 0] =&gt; -2 , [0, 1] =&gt; -3.5, [0, 2] =&gt; 4, [1, 0] =&gt; 2.2, [1, 1] =&gt; -6 , [1, 3] =&gt; -5.5}, shape: [2, 4]}","ref":"Tensorex.Operator.html#negate/1","title":"Tensorex.Operator.negate/1","type":"function"},{"doc":"Subtracts a tensor from another.iex&gt; Tensorex.Operator.subtract( ...&gt; Tensorex.from_list([[0, 1, 2], [3, -4, -5.5]]), ...&gt; Tensorex.from_list([[3, -2, -2], [6, -8.1, 12 ]])) %Tensorex{data: %{[0, 0] =&gt; -3, [0, 1] =&gt; 3 , [0, 2] =&gt; 4 , [1, 0] =&gt; -3, [1, 1] =&gt; 4.1, [1, 2] =&gt; -17.5}, shape: [2, 3]} iex&gt; Tensorex.Operator.subtract( ...&gt; Tensorex.from_list([[0, 1, 2], [3, -4, -5.5]]), ...&gt; Tensorex.from_list([[0.0, 1, 2], [6, -8.1, 12 ]])) %Tensorex{data: %{[1, 0] =&gt; -3, [1, 1] =&gt; 4.1, [1, 2] =&gt; -17.5}, shape: [2, 3]}","ref":"Tensorex.Operator.html#subtract/2","title":"Tensorex.Operator.subtract/2","type":"function"},{"doc":"Returns a transposed tensor.iex&gt; Tensorex.Operator.transpose( ...&gt; Tensorex.from_list([[[ 2 , 5.5, -4, 0 ], ...&gt; [ 4.12, -2 , 1, 0 ]], ...&gt; [[ 3 , 1.2, 5, 8.9], ...&gt; [ 1 , 6 , 7, 1.3]]]), [{0, 2}]) %Tensorex{data: %{[0, 0, 0] =&gt; 2 , [0, 0, 1] =&gt; 3 , [0, 1, 0] =&gt; 4.12, [0, 1, 1] =&gt; 1 , [1, 0, 0] =&gt; 5.5 , [1, 0, 1] =&gt; 1.2, [1, 1, 0] =&gt; -2 , [1, 1, 1] =&gt; 6 , [2, 0, 0] =&gt; -4 , [2, 0, 1] =&gt; 5 , [2, 1, 0] =&gt; 1 , [2, 1, 1] =&gt; 7 , [3, 0, 1] =&gt; 8.9, [3, 1, 1] =&gt; 1.3}, shape: [4, 2, 2]}","ref":"Tensorex.Operator.html#transpose/2","title":"Tensorex.Operator.transpose/2","type":"function"}]